diff --git a/modules/LightRing_1-2/module.c b/modules/LightRing_1-2/module.c
index e7abe54..8416448 100644
--- a/modules/LightRing_1-2/module.c
+++ b/modules/LightRing_1-2/module.c
@@ -298,7 +298,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ LED_LLD_GPIO_ACTIVE_STATE,
+    /* active state   */ APAL_GPIO_ACTIVE_LOW,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
@@ -461,6 +461,8 @@ MIC9404xDriver moduleLldPowerSwitchVsys = {
   /* power enable GPIO  */ &moduleGpioSwVsysEn,
 };
 
+// TODO: add SNx5C3221E
+
 TLC5947Driver moduleLldLedPwm = {
   /* SPI driver         */ &MODULE_HAL_SPI_LIGHT,
   /* BLANK signal GPIO  */ &moduleGpioLightBlank,
@@ -471,177 +473,296 @@ TLC5947Driver moduleLldLedPwm = {
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <string.h>
 
 /*
- * EEPROM (AT24C01B)
+ * AT24C01BN-SH-B (EEPROM)
  */
-static int _utShellCmdCb_AlldAt24c01b(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_AT24C01B.h>
+static int _testAt24co1bShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldAt24c01b, NULL);
-  return AOS_OK;
+  return moduleTestAt24c01bShellCb(stream, argc, argv, NULL);
 }
-static ut_at24c01bdata_t _utAlldAt24c01bData = {
-  /* driver   */ &moduleLldEeprom,
-  /* timeout  */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldAt24c01b = {
-  /* name           */ "AT24C01B",
-  /* info           */ "1kbit EEPROM",
-  /* test function  */ utAlldAt24c01bFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:EEPROM",
-    /* callback */ _utShellCmdCb_AlldAt24c01b,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utAlldAt24c01bData,
-};
+AOS_SHELL_COMMAND(moduleTestAt24c01bShellCmd, "test:EEPROM", _testAt24co1bShellCmdCb);
 
 /*
  * INA219 (power monitor)
  */
-static int _utShellCmdCb_AlldIna219(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_INA219.h>
+static int _testIna219ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldIna219, "VLED (4.2V)");
-  return AOS_OK;
+  return moduleTestIna219ShellCb(stream, argc, argv, NULL);
 }
-static ut_ina219data_t _utIna219Data = {
-  /* driver           */ &moduleLldPowerMonitorVled,
-  /* expected voltage */ 4.2f,
-  /* tolerance        */ 0.2f,
-  /* timeout */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldIna219 = {
-  /* name           */ "INA219",
-  /* info           */ "power monitor",
-  /* test function  */ utAlldIna219Func,
-  /* shell command  */ {
-    /* name     */ "unittest:PowerMonitor",
-    /* callback */ _utShellCmdCb_AlldIna219,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utIna219Data,
-};
+AOS_SHELL_COMMAND(moduleTestIna219ShellCmd, "test:PowerMonitor", _testIna219ShellCmdCb);
 
 /*
  * Status LED
  */
-static int _utShellCmdCb_AlldLed(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_LED.h>
+static int _testLedShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldLed, NULL);
-  return AOS_OK;
+  return moduleTestLedShellCb(stream, argc, argv, NULL);
 }
-aos_unittest_t moduleUtAlldLed = {
-  /* name           */ "LED",
-  /* info           */ NULL,
-  /* test function  */ utAlldLedFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:StatusLED",
-    /* callback */ _utShellCmdCb_AlldLed,
-    /* next     */ NULL,
-  },
-  /* data           */ &moduleLldStatusLed,
-};
+AOS_SHELL_COMMAND(moduleTestLedShellCmd, "test:StatusLED", _testLedShellCmdCb);
 
 /*
- * Power switch driver (MIC9404x)
+ * MIC9404x (power switch)
  */
-static int _utShellCmdCb_Mic9404x(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_MIC9404x.h>
+static int _testMic9404xShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  // evaluate arguments
-  if (argc == 2) {
-    if (strcmp(argv[1], "1.8V") == 0) {
-      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV18;
-      aosUtRun(stream, &moduleUtAlldMic9404x, "1.8V");
-      moduleUtAlldMic9404x.data = NULL;
-      return AOS_OK;
-    }
-    else if (strcmp(argv[1], "3.3V") == 0) {
-      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV33;
-      aosUtRun(stream, &moduleUtAlldMic9404x, "3.3V");
-      moduleUtAlldMic9404x.data = NULL;
-      return AOS_OK;
-    }
-// The 4.2V switch is disabled due to a hardware bug.
-//    else if (strcmp(argv[1], "4.2V") == 0) {
-//      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV42;
-//      aosUtRun(stream, &moduleUtAlldMic9404x, "4.2V");
-//      moduleUtAlldMic9404x.data = NULL;
-//      return AOS_OK;
-//    }
-    else if (strcmp(argv[1], "5.0V") == 0) {
-      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV50;
-      aosUtRun(stream, &moduleUtAlldMic9404x, "5.0V");
-      moduleUtAlldMic9404x.data = NULL;
-      return AOS_OK;
-    }
-    else if (strcmp(argv[1], "VSYS") == 0) {
-      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchVsys;
-      aosUtRun(stream, &moduleUtAlldMic9404x, "VSYS");
-      moduleUtAlldMic9404x.data = NULL;
-      return AOS_OK;
-    }
-  }
-  // print help
-  chprintf(stream, "Usage: %s OPTION\n", argv[0]);
-  chprintf(stream, "Options:\n");
-  chprintf(stream, "  1.8V\n");
-  chprintf(stream, "    Test power switch for 1.8V supply.\n");
-  chprintf(stream, "  3.3V\n");
-  chprintf(stream, "    Test power switch for 3.3V supply.\n");
-// The 4.2V switch is disabled due to a hardware bug.
-//  chprintf(stream, "  4.2V\n");
-//  chprintf(stream, "    Test power switch for 4.2V supply.\n");
-  chprintf(stream, "  5.0V\n");
-  chprintf(stream, "    Test power switch for 5.0V supply.\n");
-  chprintf(stream, "  VSYS\n");
-  chprintf(stream, "    Test power switch for VSYS supply.\n");
-  return AOS_INVALIDARGUMENTS;
+  return moduleTestMic9404xShellCb(stream, argc, argv, NULL);
 }
-aos_unittest_t moduleUtAlldMic9404x = {
-  /* info           */ "MIC9404x",
-  /* name           */ "power swicth driver",
-  /* test function  */ utAlldMic9404xFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:PowerSwitch",
-    /* callback */ _utShellCmdCb_Mic9404x,
-    /* next     */ NULL,
-  },
-  /* data           */ NULL,
-};
+AOS_SHELL_COMMAND(moduleTestMic9404xShellCmd, "test:PowerSwitch", _testMic9404xShellCmdCb);
+
+// TODO: add SNx5C3221E
+
+/*
+ * TLC5947 (24 channel PWM LED driver)
+ */
+#include <module_test_TLC5947.h>
+static int _testTlc5947ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  return moduleTestTlc5947ShellCb(stream, argc, argv, NULL);
+}
+AOS_SHELL_COMMAND(moduleTestTlc5947ShellCmd, "test:Lights", _testTlc5947ShellCmdCb);
 
 /*
- * LED PWM driver (TLC5947)
+ * entire module
  */
-static int _utShellCmdCb_Tlc5947(BaseSequentialStream* stream, int argc, char* argv[])
+static int _testAllShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
   (void)argc;
   (void)argv;
-  aosUtRun(stream, &moduleUtAlldTlc5947, NULL);
-  return AOS_OK;
+
+  int status = AOS_OK;
+  char* targv[AMIROOS_CFG_SHELL_MAXARGS] = {NULL};
+  aos_testresult_t result_test = {0, 0};
+  aos_testresult_t result_total = {0, 0};
+
+  /* AT24C01B (EEPROM) */
+  status |= moduleTestAt24c01bShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* INA219 (power monitor) */
+  status |= moduleTestIna219ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* Status LED */
+  status |= moduleTestLedShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* MIC9404x (power switch) */
+  // 1.8V
+  targv[1] = "1.8V";
+  status |= moduleTestMic9404xShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // 3.3V
+  targv[1] = "3.3V";
+  status |= moduleTestMic9404xShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+// The 4.2V switch is disabled due to a hardware bug.
+//  // 4.2V
+//  targv[1] = "4.2V";
+//  status |= moduleTestMic9404xShellCb(stream, 2, targv, &result_test);
+//  result_total = aosTestResultAdd(result_total, result_test);
+  // 5.0V
+  targv[1] = "5.0V";
+  status |= moduleTestMic9404xShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  //VSYS
+  targv[1] = "VSYS";
+  status |= moduleTestMic9404xShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  // TODO: add SNx5C3221E
+
+  /* TLC5947 (24 channel PWM LED driver) */
+  status |= moduleTestTlc5947ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  // print total result
+  chprintf(stream, "\n");
+  aosTestResultPrintSummary(stream, &result_total, "entire module");
+
+  return status;
 }
-aos_unittest_t moduleUtAlldTlc5947 = {
-  /* info           */ "TLC5947",
-  /* name           */ "LED PWM driver",
-  /* test function  */ utAlldTlc5947Func,
-  /* shell command  */ {
-    /* name     */ "unittest:Lights",
-    /* callback */ _utShellCmdCb_Tlc5947,
-    /* next     */ NULL,
-  },
-  /* data           */ &moduleLldLedPwm,
-};
+AOS_SHELL_COMMAND(moduleTestAllShellCmd, "test:all", _testAllShellCmdCb);
+
+
+
+
+//#include <string.h>
+
+///*
+// * EEPROM (AT24C01B)
+// */
+//static int _utShellCmdCb_AlldAt24c01b(BaseSequentialStream* stream, int argc, char* argv[])
+//{
+//  (void)argc;
+//  (void)argv;
+//  aosUtRun(stream, &moduleUtAlldAt24c01b, NULL);
+//  return AOS_OK;
+//}
+//static ut_at24c01bdata_t _utAlldAt24c01bData = {
+//  /* driver   */ &moduleLldEeprom,
+//  /* timeout  */ MICROSECONDS_PER_SECOND,
+//};
+//aos_unittest_t moduleUtAlldAt24c01b = {
+//  /* name           */ "AT24C01B",
+//  /* info           */ "1kbit EEPROM",
+//  /* test function  */ utAlldAt24c01bFunc,
+//  /* shell command  */ {
+//    /* name     */ "unittest:EEPROM",
+//    /* callback */ _utShellCmdCb_AlldAt24c01b,
+//    /* next     */ NULL,
+//  },
+//  /* data           */ &_utAlldAt24c01bData,
+//};
+
+///*
+// * INA219 (power monitor)
+// */
+//static int _utShellCmdCb_AlldIna219(BaseSequentialStream* stream, int argc, char* argv[])
+//{
+//  (void)argc;
+//  (void)argv;
+//  aosUtRun(stream, &moduleUtAlldIna219, "VLED (4.2V)");
+//  return AOS_OK;
+//}
+//static ut_ina219data_t _utIna219Data = {
+//  /* driver           */ &moduleLldPowerMonitorVled,
+//  /* expected voltage */ 4.2f,
+//  /* tolerance        */ 0.2f,
+//  /* timeout */ MICROSECONDS_PER_SECOND,
+//};
+//aos_unittest_t moduleUtAlldIna219 = {
+//  /* name           */ "INA219",
+//  /* info           */ "power monitor",
+//  /* test function  */ utAlldIna219Func,
+//  /* shell command  */ {
+//    /* name     */ "unittest:PowerMonitor",
+//    /* callback */ _utShellCmdCb_AlldIna219,
+//    /* next     */ NULL,
+//  },
+//  /* data           */ &_utIna219Data,
+//};
+
+///*
+// * Status LED
+// */
+//static int _utShellCmdCb_AlldLed(BaseSequentialStream* stream, int argc, char* argv[])
+//{
+//  (void)argc;
+//  (void)argv;
+//  aosUtRun(stream, &moduleUtAlldLed, NULL);
+//  return AOS_OK;
+//}
+//aos_unittest_t moduleUtAlldLed = {
+//  /* name           */ "LED",
+//  /* info           */ NULL,
+//  /* test function  */ utAlldLedFunc,
+//  /* shell command  */ {
+//    /* name     */ "unittest:StatusLED",
+//    /* callback */ _utShellCmdCb_AlldLed,
+//    /* next     */ NULL,
+//  },
+//  /* data           */ &moduleLldStatusLed,
+//};
+
+///*
+// * Power switch driver (MIC9404x)
+// */
+//static int _utShellCmdCb_Mic9404x(BaseSequentialStream* stream, int argc, char* argv[])
+//{
+//  // evaluate arguments
+//  if (argc == 2) {
+//    if (strcmp(argv[1], "1.8V") == 0) {
+//      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV18;
+//      aosUtRun(stream, &moduleUtAlldMic9404x, "1.8V");
+//      moduleUtAlldMic9404x.data = NULL;
+//      return AOS_OK;
+//    }
+//    else if (strcmp(argv[1], "3.3V") == 0) {
+//      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV33;
+//      aosUtRun(stream, &moduleUtAlldMic9404x, "3.3V");
+//      moduleUtAlldMic9404x.data = NULL;
+//      return AOS_OK;
+//    }
+//// The 4.2V switch is disabled due to a hardware bug.
+////    else if (strcmp(argv[1], "4.2V") == 0) {
+////      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV42;
+////      aosUtRun(stream, &moduleUtAlldMic9404x, "4.2V");
+////      moduleUtAlldMic9404x.data = NULL;
+////      return AOS_OK;
+////    }
+//    else if (strcmp(argv[1], "5.0V") == 0) {
+//      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchV50;
+//      aosUtRun(stream, &moduleUtAlldMic9404x, "5.0V");
+//      moduleUtAlldMic9404x.data = NULL;
+//      return AOS_OK;
+//    }
+//    else if (strcmp(argv[1], "VSYS") == 0) {
+//      moduleUtAlldMic9404x.data = &moduleLldPowerSwitchVsys;
+//      aosUtRun(stream, &moduleUtAlldMic9404x, "VSYS");
+//      moduleUtAlldMic9404x.data = NULL;
+//      return AOS_OK;
+//    }
+//  }
+//  // print help
+//  chprintf(stream, "Usage: %s OPTION\n", argv[0]);
+//  chprintf(stream, "Options:\n");
+//  chprintf(stream, "  1.8V\n");
+//  chprintf(stream, "    Test power switch for 1.8V supply.\n");
+//  chprintf(stream, "  3.3V\n");
+//  chprintf(stream, "    Test power switch for 3.3V supply.\n");
+//// The 4.2V switch is disabled due to a hardware bug.
+////  chprintf(stream, "  4.2V\n");
+////  chprintf(stream, "    Test power switch for 4.2V supply.\n");
+//  chprintf(stream, "  5.0V\n");
+//  chprintf(stream, "    Test power switch for 5.0V supply.\n");
+//  chprintf(stream, "  VSYS\n");
+//  chprintf(stream, "    Test power switch for VSYS supply.\n");
+//  return AOS_INVALIDARGUMENTS;
+//}
+//aos_unittest_t moduleUtAlldMic9404x = {
+//  /* info           */ "MIC9404x",
+//  /* name           */ "power swicth driver",
+//  /* test function  */ utAlldMic9404xFunc,
+//  /* shell command  */ {
+//    /* name     */ "unittest:PowerSwitch",
+//    /* callback */ _utShellCmdCb_Mic9404x,
+//    /* next     */ NULL,
+//  },
+//  /* data           */ NULL,
+//};
+
+///*
+// * LED PWM driver (TLC5947)
+// */
+//static int _utShellCmdCb_Tlc5947(BaseSequentialStream* stream, int argc, char* argv[])
+//{
+//  (void)argc;
+//  (void)argv;
+//  aosUtRun(stream, &moduleUtAlldTlc5947, NULL);
+//  return AOS_OK;
+//}
+//aos_unittest_t moduleUtAlldTlc5947 = {
+//  /* info           */ "TLC5947",
+//  /* name           */ "LED PWM driver",
+//  /* test function  */ utAlldTlc5947Func,
+//  /* shell command  */ {
+//    /* name     */ "unittest:Lights",
+//    /* callback */ _utShellCmdCb_Tlc5947,
+//    /* next     */ NULL,
+//  },
+//  /* data           */ &moduleLldLedPwm,
+//};
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
diff --git a/modules/LightRing_1-2/module.h b/modules/LightRing_1-2/module.h
index fd221db..ffb29a4 100644
--- a/modules/LightRing_1-2/module.h
+++ b/modules/LightRing_1-2/module.h
@@ -298,18 +298,19 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Unit test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldAt24c01b.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldIna219.shellcmd);               \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLed.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldMic9404x.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTlc5947.shellcmd);              \
+  /* initialize tests and add to shell */                                     \
+  aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestIna219ShellCmd);                  \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestMic9404xShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestTlc5947ShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
 
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* I2C */                                                                   \
@@ -324,7 +325,7 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   /* SPI */                                                                   \
   spiStop(&MODULE_HAL_SPI_LIGHT);                                             \
   /* I2C */                                                                   \
@@ -393,7 +394,7 @@ extern ROMCONST char* moduleShellPrompt;
 #include <alld_INA219.h>
 #include <alld_LED.h>
 #include <alld_MIC9404x.h>
-//#include <alld_SNx5C3221E.h>
+// TODO: add SNx5C3221E
 #include <alld_TLC5947.h>
 
 /**
@@ -437,8 +438,10 @@ extern MIC9404xDriver moduleLldPowerSwitchV50;
  */
 extern MIC9404xDriver moduleLldPowerSwitchVsys;
 
+// TODO: add SNx5C3221E
+
 /**
- * @brief   LED PWM driver.
+ * @brief   24 channel PWM LED driver.
  */
 extern TLC5947Driver moduleLldLedPwm;
 
@@ -446,42 +449,43 @@ extern TLC5947Driver moduleLldLedPwm;
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <ut_alld_AT24C01B_v1.h>
-#include <ut_alld_INA219_v1.h>
-#include <ut_alld_LED_v1.h>
-#include <ut_alld_MIC9404x_v1.h>
-//#include <ut_alld_SNx5C3221E_v1.h>
-#include <ut_alld_TLC5947_v1.h>
 
 /**
- * @brief   EEPROM unit test object.
+ * @brief   AT24C01BN-SH-B (EEPROM) test command.
  */
-extern aos_unittest_t moduleUtAlldAt24c01b;
+extern aos_shellcommand_t moduleTestAt24c01bShellCmd;
 
 /**
- * @brief   INA219 (power monitor) unit test object.
+ * @brief   INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldIna219;
+extern aos_shellcommand_t moduleTestIna219ShellCmd;
 
 /**
- * @brief   Status LED unit test object.
+ * @brief   Status LED test command.
  */
-extern aos_unittest_t moduleUtAlldLed;
+extern aos_shellcommand_t moduleTestLedShellCmd;
+
+/**
+ * @brief   MIC9404x (power switch) test command.
+ */
+extern aos_shellcommand_t moduleTestMic9404xShellCmd;
+
+// TODO: add SNx5C3221E
 
 /**
- * @brief   Power switch unit test object.
+ * @brief   TLC5947 (24 channel PWM LED driver) test command.
  */
-extern aos_unittest_t moduleUtAlldMic9404x;
+extern aos_shellcommand_t moduleTestTlc5947ShellCmd;
 
 /**
- * @brief   LED PWM driver unit test object.
+ * @brief   Entire module test command.
  */
-extern aos_unittest_t moduleUtAlldTlc5947;
+extern aos_shellcommand_t moduleTestAllShellCmd;
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
diff --git a/modules/LightRing_1-2/test/AT24C01B/module_test_AT24C01B.c b/modules/LightRing_1-2/test/AT24C01B/module_test_AT24C01B.c
new file mode 100644
index 0000000..ee88d4c
--- /dev/null
+++ b/modules/LightRing_1-2/test/AT24C01B/module_test_AT24C01B.c
@@ -0,0 +1,71 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_AT24C01B.h>
+#include <aos_test_AT24C01B.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_at24c01bdata_t _data = {
+  /* driver   */ &moduleLldEeprom,
+  /* timeout  */ MICROSECONDS_PER_SECOND,
+};
+
+static AOS_TEST(_test, "AT24C01BN-SH-B", "1kbit EEPROM", moduleTestAt24c01bShellCb, aosTestAt24c01bFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestAt24c01bShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/LightRing_1-2/test/AT24C01B/module_test_AT24C01B.h b/modules/LightRing_1-2/test/AT24C01B/module_test_AT24C01B.h
new file mode 100644
index 0000000..6764c0d
--- /dev/null
+++ b/modules/LightRing_1-2/test/AT24C01B/module_test_AT24C01B.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_AT24C01B_H
+#define MODULE_TEST_AT24C01B_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+   int moduleTestAt24c01bShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_AT24C01B_H */
+
diff --git a/modules/LightRing_1-2/test/INA219/module_test_INA219.c b/modules/LightRing_1-2/test/INA219/module_test_INA219.c
new file mode 100644
index 0000000..bda325b
--- /dev/null
+++ b/modules/LightRing_1-2/test/INA219/module_test_INA219.c
@@ -0,0 +1,73 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_INA219.h>
+#include <aos_test_INA219.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_ina219data_t _data = {
+  /* driver           */ &moduleLldPowerMonitorVled,
+  /* expected voltage */ 4.2f,
+  /* tolerance        */ 0.2f,
+  /* timeout */ MICROSECONDS_PER_SECOND,
+};
+
+static AOS_TEST(_test, "INA219", "power monitor", moduleTestIna219ShellCb, aosTestIna219Func, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestIna219ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
